class AnimateParticle{

  int counter = 0;
  XMLdata songdatas;

  Particle p, p2, p3;  
  ArrayList particles;   //An arraylist for all the particles

    float x, y1, y2 ,y3 , z1, z2, z3, r; //particel position x, y, z and radius or particle

  color col;  //color for particle
  float amp;
  int currentSegmentIndex = 0;

  PImage img;
  PImage shadow_msk;

  AnimateParticle(XMLdata datas, PImage img_, PImage shadow_msk_){
    songdatas = datas;             //store the xml data
    particles = new ArrayList();  //initialize the arraylist 

      img = img_;
    shadow_msk = shadow_msk_; 

  }

  void drawData(AudioPlayer song, float amp_){

    float m = song.position()-110;  

    amp = amp_*50; //amplitue 

    //println(" songdatas.stTime[currentSegmentIndex] = "+  songdatas.stTime[currentSegmentIndex]+ " m = " + m);

    //if the next segment has happened
    while( songdatas.stTime[currentSegmentIndex]*1000 < m) {

      // println(songdatas.stTime[currentSegmentIndex] + "   " + song.position()/1000);
      addParticle(currentSegmentIndex, amp); //add new particle

      if(currentSegmentIndex< songdatas.stTime.length-1){
        currentSegmentIndex++;
      }

    }

  }

  void addParticle(int currentSegmentIndex, float amp){

    int temp = songdatas.numSegments; 
    float temp_z = ((songdatas.durationSeg[currentSegmentIndex]*(-5000))/3);

    //set a particle x, y, z, radius and color
    x = map( songdatas.stTime[currentSegmentIndex], 0 , songdatas.stTime[temp-1], (width-winSizeX)/2, (width-winSizeX)/2+winSizeX);

    y1 =  map( songdatas.loudness[currentSegmentIndex][0], songdatas.minLoud_at_Begin, songdatas.maxLoud_at_Begin, (height-winSizeY)/2+winSizeY, (height-winSizeY)/2);
    y2=  map( songdatas.loudness[currentSegmentIndex][1], songdatas.minLoud_at_Begin, songdatas.maxLoud_at_Begin, (height-winSizeY)/2+winSizeY, (height-winSizeY)/2);
    y3 =  map( songdatas.loudness[currentSegmentIndex][2], songdatas.minLoud_at_Begin, songdatas.maxLoud_at_Begin, (height-winSizeY)/2+winSizeY, (height-winSizeY)/2);

    r = map( songdatas.stTime[currentSegmentIndex], 0 , songdatas.durationSeg[temp-1], 2, 100);  

    z1 = temp_z;
    z2 = temp_z*2;
    z3 = temp_z*3;

    strokeWeight(amp);

    // connectLine( x,  y1,  z1,  x,  y2,  z2);
    // connectLine(x, y2, z2, x, y3, z3);

    //fill(255);
    drawText(currentSegmentIndex,x,y1, z1);
    drawText(currentSegmentIndex,x,y2, z2);
    drawText(currentSegmentIndex,x,y3, z3);

    drawCircle(x, y2, z2,  (amp*100)%300);
    drawCircle(x, y1, z1,  (amp*100)%300);
    drawCircle(x, y3, z3, (amp*100)%300);

    drawImg(x, y2, z2, amp*10);
    drawImg(x, y1, z1, amp*10);
    drawImg(x, y3, z3, amp*10);
  }



  void connectLine(float x1, float y1, float z1, float x2, float y2, float z2){
    stroke(col, 40);
    // stroke(255,255,255, 40);
    strokeWeight(3);

    float temp = abs(y2-y1)/2;
    float tempPos1;

    noFill();
    beginShape();
    curveVertex(x1, y1, z1);
    curveVertex(x1, y1, z1);
    curveVertex(x1, height/2 + abs(y2-y1)/2, z1+((abs(z2) -abs(z1))/2*-1));
    curveVertex(x1, (height-winSizeY)/2 + abs(y2-y1)/2, z1+((abs(z2) -abs(z1))/2*-1));
    curveVertex(x2, y2, z2);
    curveVertex(x2, y2, z2);
    endShape();

  }

  void drawText(int index, float x, float y, float z){
    fill(255-((amp*100)%255),0,(amp*100)%255);
    textFont(font2);
    stroke(255, 255, 255, 20);
    strokeWeight(0.1);
    line(x,  (height-winSizeY)/2+winSizeY, z, x , y, z);
    text(index, x, (height-winSizeY)/2+winSizeY,z);
  }

  void drawCircle(float x, float y, float z, float r){

    float s = amp%5;
   
    stroke(255,255,255, 40);
    strokeWeight(s);
    
    pushMatrix();
    noFill();
    translate(x, y, z);
    rotateX(90);
    ellipse(0, 0, r*s, r*s);
    popMatrix();

    pushMatrix();
    noFill();
    translate(x, y, z);
    rotateY(90);
    ellipse(0, 0, r*s, r*s);
    popMatrix();
  }

  void drawImg(float x, float y, float z, float r){

    pushMatrix();
    noFill();
    translate(x, y, z);
    rotateX(90);
    tint(255,255,255, 150);
    image(img, 0-(r/2),  0-(r/2),  r,  r);
    popMatrix();

    pushMatrix();
    noFill();
    translate(x, y, z);
    rotateY(90);
    tint(255,255,255, 150);
    image(img,  0-(r/2),  0-(r/2),  r,  r);
    popMatrix();

  }


}





