class Particle{

  Vector3D loc; //x, y, z
  Vector3D vel; //speed
  Vector3D acc; //acceleration

  float s_radius; // particle size
  float timer;
  float beat;
  
  // Create an alpha masked image to be applied as the particle's texture
  PImage img;
  PImage shadow_msk;

  color col;

  Particle(Vector3D l, Vector3D v, Vector3D a, float sizeR, color col, PImage img_, PImage shadow_msk_){
    loc = l.copy();
    vel = new Vector3D(random(-1,1),random(-2,0),0);
    acc = a.copy();

    s_radius = sizeR;

    this.col =col;
    timer = 100.0;

    img = img_;
    shadow_msk = shadow_msk_;
    
  }

  // for Debugging
  Particle(Vector3D l, float r_, PImage img_, PImage shadow_msk_, color col_, float b_) {
     beat = b_;
    acc = new Vector3D(0,0,0);
     //acc = new Vector3D(random(-1,1),random(-2,0),0);
     
    vel = new Vector3D(0,0,0);
    //vel = new Vector3D(random(-1,1),random(-2,0),0);
    loc = l.copy();
    s_radius= r_;
    timer = 100.0;
    
    img = img_;
    shadow_msk = shadow_msk_;
    col = col_;
   
  }

  void run() {
    update();
    timer();
    render();
    
  }

  // Method to update location
  void update() {
    vel.add(acc);
    loc.add(vel);
  }

  void timer() {
    timer -= 0.5;
  }


  //render img particle
  void render(){
    renderEllipse();

  }

  void drawShadow(){
    pushMatrix();
    imageMode(CORNER);
    tint(col, 150);
    translate(loc.x, loc.y, loc.z); //3D version
    image(shadow_img, -(s_radius+3),  -(s_radius+3),  s_radius*3,  s_radius*3);
     popMatrix(); 
  }
  // Is the particle still useful?
  boolean dead() {
    if (timer <= 0.0) {
      return true;
    } 
    else {
      return false;
    }
  }


  //For Debugging Purpose
   //render ellipse particle
   void renderEllipse(){
   
   stroke(col,100);
   noFill();
   ellipseMode(CENTER);
   
   pushMatrix();
   translate(loc.x, loc.y, loc.z);
   popMatrix();
   
   }
   
   

}
