class XMLdata{

  XMLInOut xml;

  XMLElement track, tags, tatums;
  XMLElement[] sections;
  XMLElement[] tagArr = new XMLElement[0];

  float tempo,durationOfSong;
  int numTatums, numSections, numBeats, numSegments, trackDuration;  

  float minPitch, maxPitch, minTim, maxTim;
  float minLoud_at_Begin, maxLoud_at_Begin, minLoud_at_Max, maxLoud_at_Max, minLoud_at_End, maxLoud_at_End;
  
  float[] tatumsNumber = new float[0]; //tatum number
  float[] stTime; //start time for each segment
  float[] durationSeg; //start time for each segment
  float[][] loudness; //loudness in each segment 
  float[][] pitches ; //12 pitch in each segment 
  float[][] timbre; //12 timbre in each segment

  XMLdata(){
    sections = new XMLElement[0];
  }

  void parseElement (XMLElement element){

    track = element.getChild(1);
    durationOfSong = track.getFloatAttribute("duration");
    trackDuration = int(durationOfSong*1000);

    tags = track.getChild(0);
    storeTagsAttribute(tags);

    tatums = track.getChild(1);
    storeTatum(tatums);

    //set all array size for informaiton
    stTime = new float[numSegments];
    durationSeg = new float[numSegments];
    loudness = new float[numSegments][3];
    pitches = new float[numSegments][12];
    timbre = new float[numSegments][12];

    for(int i=2; i< numSegments+2; i++){

      //store Start time in each segment 
      float temp_stTime = track.getChild(i+numSections).getFloatAttribute("start");
      stTime[i-2] = temp_stTime;
      
     float temp_dur = track.getChild(i+numSections).getFloatAttribute("duration");
      durationSeg[i-2] = temp_dur;
      
      //store tag in each segment
      storeTagInfo(track.getChild(i+numSections).firstChild());

    }

    isXMLParsedDone();

  } 

  //store tags item 
  void storeTagsAttribute(XMLElement tags){
 
    numTatums = tags.getIntAttribute("numTatums");
    tempo = tags.getFloatAttribute("tempo");
    numSections = tags.getIntAttribute("numSections");
    numBeats = tags.getIntAttribute("numBeats");
    numSegments = tags.getIntAttribute("numSegments");

  }

  //store tatums number 
  void storeTatum(XMLElement tatums){

    int counter = 0; //count tatums number

    String tatumsNumString = tatums.firstChild().getText();
    String[] tatumsNum_split = split(tatumsNumString, ' ');

    //store tatums number 
    for(int i=0; i<tatumsNum_split.length; i++){
      tatumsNumber = (float[])append (tatumsNumber, float(tatumsNum_split[i]));
      counter++;
    }
    //println("tatumNumber = " + counter);
  }

  void storeTagInfo(XMLElement tags){

    tagArr = (XMLElement[])append(tagArr, tags);

    String pitchTemp;
    String[] pitch_split;

    String timbreTemp;
    String[] timbre_split;

    //store pitches
    for(int i=0; i< tagArr.length; i++){       
  
      //Y axis
      loudness[i][0] = tagArr[i].getFloatAttribute("loudnessBegin");  //store loudness
      loudness[i][1] = tagArr[i].getFloatAttribute("loudnessMax");  //store loudness
      loudness[i][2] = tagArr[i].getFloatAttribute("loudnessEnd");  //store loudness
      
      pitchTemp = tagArr[i].getAttribute("pitches");
      pitch_split = split(pitchTemp, ' ');

      timbreTemp = tagArr[i].getAttribute("timbreCoeff");
      timbre_split = split(timbreTemp, ' ');

      for(int j=0; j< 12; j++){
        pitches[i][j] =float(pitch_split[j]);
        timbre[i][j] =float(timbre_split[j]);
      }

    }

  }


  //Debugging purpose
  void isXMLParsedDone(){

    println("loudness" + loudness[numSegments-1][2]);
    println("pitches" + pitches[numSegments-1][11]);
    println("timbre" + timbre[numSegments-1][11]);
    println("Totalsegment " + numSegments);
    setMinMax();
  }


 //helper function to set the min and max for pitch, timbre, loudness
 
 void setMinMax(){
  
   minPitch = setMin(pitches);
   maxPitch = setMax(pitches);
   
   minLoud_at_Begin  = setLoudMin(loudness);
   maxLoud_at_Begin = setMax(loudness);
   
   //minLoud_at_Max  = setLoudMin(loudness);
   //maxLoud_at_Max = setMax(loudness);
   
   //minLoud_at_End  = setLoudMin(loudness);
   //maxLoud_at_End = setMax(loudness);
   
   minTim  = setMin(timbre);
   maxTim  = setMax(timbre);
   
   println("minPitch = " + minPitch + " maxPitch = " + maxPitch);
   println("minLoud_at_Begin = " + minLoud_at_Begin+ " maxLoud_at_Max = " +  maxLoud_at_Begin);
   //println("minLoud_at_Max = " +  minLoud_at_Max + " maxLoud_at_Max = " +  maxLoud_at_Max);
   //println("minLoud_at_End = " +  minLoud_at_End + " maxLoud_at_End = " +  maxLoud_at_End);
   println("minTim = " + minTim + " maxTim = " + maxTim);
  
 }

 //return the min number for for one dimentional array
  float setMin(float[] datas){

    float tempMin = 10000;

    for(int i = 0; i < datas.length; i++){

      float temp = datas[i];

      if(temp < tempMin){
        tempMin = temp;
      }
    }
    return tempMin;
  }
   

 //return the min number for two dimentional array
 float setMin(float[][] datas){

    float tempMin = 10000;

    for(int i = 0; i < datas.length; i++){
       for (int j=0; j < datas[i].length; j++){
          float temp = datas[i][j];

            if(temp < tempMin){
                tempMin = temp;
              }
        }  
  }
    return tempMin;

  }

//return the max number for for oen dimentional array
  float setMax(float[] datas){

    float tempMax = - 10000;

    for(int i = 0; i < datas.length; i++){

      float temp = datas[i];

      if(temp > tempMax){
        tempMax = temp;
      }
    }
    return tempMax;
  }
   

 //return the max number for two dimentional array
 float setMax(float[][] datas){

    float tempMax = - 10000;

    for(int i = 0; i < datas.length; i++){
       for (int j=0; j < datas[i].length; j++){
          float temp = datas[i][j];

            if(temp > tempMax){
                tempMax = temp;
              }
        }  
  }
    return tempMax;

  }



  //set loudness min
 //return the min number for for oen dimentional array
  float setLoudMin(float[][] datas){

    float tempMin = 10000;

    for(int i = 1; i < datas.length; i++){
      for(int j= 0; j < datas[i].length; j++){
      float temp = datas[i][j];

      if(temp < tempMin){
        tempMin = temp;
      }
      }
    }
    return tempMin;
  }

}

